diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/cook.c tin-2.6.5/src/cook.c
--- tin-2.6.4/src/cook.c	2024-12-04 18:12:24.000000000 +0100
+++ tin-2.6.5/src/cook.c	2025-12-13 09:50:24.183556469 +0100
@@ -3,10 +3,10 @@
  *  Module    : cook.c
  *  Author    : J. Faultless
  *  Created   : 2000-03-08
- *  Updated   : 2024-12-04
+ *  Updated   : 2025-12-09
  *  Notes     : Split from page.c
  *
- * Copyright (c) 2000-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 2000-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,7 +51,7 @@
 			if ((l = offsets[1] - offsets[0])) { \
 				u = my_strndup(line + offsets[0], l); \
 				if (*(u + l - 1) == '\n') \
-					*(u + l -1) = '\0'; \
+					*(u + l - 1) = '\0'; \
 				if (*u) { \
 					state.uri = &uri; \
 					if (uriParseUriA(&state, u) == URI_SUCCESS) { \
@@ -64,28 +64,65 @@
 			} \
 		} \
 	} while (0)
+#else
+#ifdef HAVE_LIBCURL
+#	include <curl/curl.h>
+#	define CHECK_URI(r,f)	do { \
+		if (MATCH_REGEX(r, line, len)) { \
+			offsets = regex_get_ovector_pointer(&r); \
+			if ((l = offsets[1] - offsets[0])) { \
+				u = my_strndup(line + offsets[0], l); \
+				if (*(u + l - 1) == '\n') \
+					*(u + l - 1) = '\0'; \
+				if (*u) { \
+					if ((curl = curl_url())) { \
+						if (curl_url_set(curl, CURLUPART_URL, u, CURLU_URLENCODE) == CURLUE_OK) { \
+							if (curl_url_get(curl, CURLUPART_URL, &nu, 0) == CURLUE_OK) { \
+								curl_free(nu); \
+								flags |= f; \
+							} \
+						} \
+						curl_url_cleanup(curl); \
+					} \
+				} \
+				FreeAndNull(u); \
+			} \
+		} \
+	} while (0)
+#	endif /* HAVE_LIBCURL */
 #endif /* HAVE_LIBURIPARSER */
 /*
  * We malloc() this many t_lineinfo's at a time
  */
 #define CHUNK		50
 
+#define TEXT_SECTION			0
+#define SIGNATURE_SECTION	(1 << 0)
+#define VERBATIM_BEGIN		(1 << 1)
+#define VERBATIM_SECTION		(1 << 2)
+#define VERBATIM_END		(1 << 3)
+#define UUE_BEGIN			(1 << 4)
+#define UUE_SECTION			(1 << 5)
+#define YENC_SECTION			(1 << 6)
+#define SHAR_SECTION		(1 << 7)
+#define PGP_KEY_SECTION		(1 << 8)
+#define PGP_SIG_SECTION		(1 << 9)
+#define PGP_ANY_SECTION		(PGP_KEY_SECTION | PGP_SIG_SECTION)
+
 #define STRIP_ALTERNATIVE(x) \
 			(curr_group->attribute->alternative_handling && \
 			(x)->hdr.ext->type == TYPE_MULTIPART && \
 			strcasecmp("alternative", (x)->hdr.ext->subtype) == 0)
 
-#define MATCH_REGEX(x,y,z)	(match_regex_ex(y, (REGEX_SIZE) z, 0, 0, &(x)) >= 0)
-
 
 static char *ltobi(unsigned long i);
 static struct t_attach_item *add_attach_line_item(struct t_attach_item **item);
 static t_bool header_wanted(const char *line);
 static t_bool shorten_attach_line(struct t_attach_item *item);
 static t_part *new_uue(t_part **part, char *name);
-static void process_text_body_part(t_bool wrap_lines, FILE *in, const char *charset, t_part *part, int hide_uue);
-static void put_attach(t_bool wrap_lines, t_part *part, int depth, int is_uue, const char *name, const char *charset);
-static void put_cooked(size_t buf_len, t_bool wrap_lines, int flags, const char *fmt, ...);
+static void process_text_body_part(t_bool wrap_lines, FILE *in, const char *charset, t_part *part, int hide_inline_data);
+static void put_attach(t_bool wrap_lines, t_part *part, int depth, enum section_type section, const char *name, const char *charset);
+static void put_cooked(size_t buf_len, t_bool wrap_lines, unsigned int flags, const char *fmt, ...);
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	static t_bool wexpand_ctrl_chars(wchar_t **wline, size_t *length, size_t lcook_width);
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
@@ -229,14 +266,14 @@ static void
 put_cooked(
 	size_t buf_len,
 	t_bool wrap_lines,
-	int flags,
+	unsigned int flags,
 	const char *fmt,
 	...)
 {
 	char *p, *bufp, *buf, *last_space;
 	int wrap_column;
 	int space;
-	static int saved_flags = 0;
+	static unsigned int saved_flags = 0;
 	va_list ap;
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	int bytes;
@@ -262,6 +299,11 @@ put_cooked(
 	wp = my_malloc((MB_CUR_MAX + 1) * sizeof(wint_t));
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
+	if (art->cooked_lines == 0) {
+		art->cookl = my_malloc(sizeof(t_lineinfo) * CHUNK);
+		art->cookl[0].offset = 0;
+	}
+
 	while (*p) {
 		if (wrap_lines) {
 			space = wrap_column;
@@ -293,17 +335,11 @@ put_cooked(
 			++p;
 		bufp = p;
 
-		if (art->cooked_lines == 0) {
-			art->cookl = my_malloc(sizeof(t_lineinfo) * CHUNK);
-			art->cookl[0].offset = 0;
-		}
-
 		/*
 		 * Pick up flags from a previous partial write
 		 */
-		art->cookl[art->cooked_lines].flags = flags | saved_flags;
+		art->cookl[art->cooked_lines++].flags = flags | saved_flags;
 		saved_flags = 0;
-		art->cooked_lines++;
 
 		/*
 		 * Grow the array of lines if needed - we resize it properly at the end
@@ -354,7 +390,7 @@ new_uue(
 	 */
 	ptr->params = new_params();
 	ptr->params->name = my_strdup("name");
-	ptr->params->value = my_strdup(str_trim(name));
+	ptr->params->value = my_strdup(str_trim(name)); /* TODO: sanitize filename */
 
 	ptr->encoding = ENCODING_UUE;	/* treat as x-uuencode */
 
@@ -373,8 +409,12 @@ new_uue(
 
 /*
  * Get the suggested filename for an attachment. RFC says Content-Disposition
- * 'filename' supersedes Content-Type 'name'. We must also remove path
- * information.
+ * 'filename' supersedes Content-Type 'name'.
+ * In addition to 'filename', RFC 6266 also defines 'filename*'. Both can
+ * occur simultaneously. If both are present, 'filename*' should be used.
+ * We must also remove path information.
+ * If 'filename*' ends with '/' we fall back to 'filename', if that also ends
+ * with '/', we fall back to 'name' and if 'name ends with '/' we return NULL.
  */
 const char *
 get_filename(
@@ -383,13 +423,20 @@ get_filename(
 	const char *name;
 	char *p;
 
-	if (!(name = get_param(ptr, "filename"))) {
-		if (!(name = get_param(ptr, "name")))
-			return NULL;
+	if ((name = get_param(ptr, "filename*"))) {
+		if ((p = strrchr(name, '/')))
+			name = *++p ? p : NULL;
+	}
+
+	if (!name && (name = get_param(ptr, "filename"))) {
+		if ((p = strrchr(name, '/')))
+			name = *++p ? p : NULL;
 	}
 
-	if ((p = strrchr(name, '/')))
-		return p + 1;
+	if (!name && (name = get_param(ptr, "name"))) {
+		if ((p = strrchr(name, '/')))
+			name = *++p ? p : NULL;
+	}
 
 	return name;
 }
@@ -410,14 +457,13 @@ get_filename(
 	} while (0)
 
 #define INSERT_SEP() do { \
-		if (curr->prev && (curr->flags & (ATTACH_SHOW_CONTENT | ATTACH_SHOW_BOTH)) && (space_left -= strlen(_(txt_mime_sep)) > 0)) { \
+		if (curr->prev && (curr->flags & (ATTACH_SHOW_CONTENT | ATTACH_SHOW_BOTH)) && ((space_left -= strlen(_(txt_mime_sep))) > 0)) { \
 			strcat(attach_line, _(txt_mime_sep)); \
-			al_ptr = attach_line + strlen(attach_line); \
 		} \
 	} while (0)
 
 #define INSERT_SLASH() do { \
-		if ((curr->flags & (ATTACH_SHOW_CONTENT | ATTACH_SHOW_BOTH)) && (space_left -= 2 > 0)) { \
+		if ((curr->flags & (ATTACH_SHOW_CONTENT | ATTACH_SHOW_BOTH)) && ((space_left -= 2) > 0)) { \
 			*al_ptr++ = '/'; \
 			*al_ptr = '\0'; \
 		} \
@@ -429,7 +475,7 @@ get_filename(
 				snprintf(buf, blen, curr->description, curr->content); \
 			else \
 				snprintf(buf, blen, curr->fmt, curr->content); \
-			if ((space_left -= strlen(buf) > 0)) \
+			if ((space_left -= strlen(buf)) > 0) \
 				strcat(attach_line, buf); \
 		} \
 		curr = curr->next; \
@@ -497,23 +543,30 @@ build_attach_line(
 	const t_part *part,
 	int depth,
 	int max_len,
-	int is_uue,
+	enum section_type section,
 	const char *name,
 	const char *charset)
 {
 	char *attach_line;
 	char *al_ptr;
 	char *fmt_ptr;
+	char *bytes_str = NULL;
+	char *crc_str = NULL;
 	char *line_cnt_str = NULL;
+	char *part_size_str = NULL;
+	char *part_str = NULL;
+	char *total_size_str = NULL;
+	char *total_str = NULL;
 	char *buf;
 	char *fmt;
-	int i, line_cnt_str_len;
+	int i, str_len, space_left;
 	size_t blen;
-	ssize_t space_left;
 	struct t_attach_item *curr = NULL;
 	struct t_attach_item *items = NULL;
 	struct t_attach_item *last;
 	t_bool init = TRUE;
+	t_bool is_uue = (section == SECTION_UUE_COMPLETE || section == SECTION_UUE_INCOMPLETE);
+	t_bool is_yenc = (section >= SECTION_YENC_COMPLETE /* && section <= SECTION_YENC_CORRUPT */);
 	t_bool excl_seen = FALSE;
 	t_bool star_seen = FALSE;
 
@@ -524,12 +577,31 @@ build_attach_line(
 	buf = my_malloc(cCOLS + 1);
 	blen = (size_t) cCOLS;
 #	endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-	if (is_uue)
-		fmt = tinrc.page_uue_format;
-	else if (signal_context == cAttachment)
-		fmt = tinrc.attachment_format;
-	else
-		fmt = tinrc.page_mime_format;
+
+	if (signal_context == cAttachment)
+		section = SECTION_ATTACHMENT;
+
+	switch (section) {
+		case SECTION_UUE_COMPLETE:
+		case SECTION_UUE_INCOMPLETE:
+			fmt = tinrc.page_uue_format;
+			break;
+
+		case SECTION_YENC_COMPLETE:
+		case SECTION_YENC_INCOMPLETE:
+		case SECTION_YENC_PARTIAL:
+		case SECTION_YENC_CORRUPT:
+			fmt = tinrc.page_yenc_format;
+			break;
+
+		case SECTION_ATTACHMENT:
+			fmt = tinrc.attachment_format;
+			break;
+
+		default:
+			fmt = tinrc.page_mime_format;
+			break;
+	}
 
 	fmt_ptr = fmt;
 	for (; *fmt_ptr; fmt_ptr++) {
@@ -552,165 +624,246 @@ build_attach_line(
 				break;
 
 			case 'c':
+			case 'C':
 				if (charset) {
 					curr = add_attach_line_item(&items);
 					curr->content = charset;
 					curr->description = _(txt_mime_charset);
-					SMALL_LETTER_CONDITIONALS();
+					if (*fmt_ptr == 'c')
+						SMALL_LETTER_CONDITIONALS();
+					else
+						CAPITAL_LETTER_CONDITIONALS();
 				}
 				excl_seen = star_seen = FALSE;
 				break;
 
 			case 'd':
+			case 'D':
 				curr = add_attach_line_item(&items);
 				if (!line_cnt_str) {
-					line_cnt_str_len = snprintf(NULL, 0, "%d", part->line_count);
-					line_cnt_str = my_malloc(line_cnt_str_len + 1);
-					snprintf(line_cnt_str, line_cnt_str_len + 1, "%d", part->line_count);
+					str_len = snprintf(NULL, 0, "%d", part->line_count);
+					line_cnt_str = my_malloc(str_len + 1);
+					snprintf(line_cnt_str, str_len + 1, "%d", part->line_count);
 				}
 				curr->content = line_cnt_str;
-				curr->description = _(txt_mime_lines);
-				SMALL_LETTER_CONDITIONALS();
+				curr->description = P_(txt_mime_line_sp[0], txt_mime_line_sp[1], part->line_count);
+				if (*fmt_ptr == 'd')
+					SMALL_LETTER_CONDITIONALS();
+				else
+					CAPITAL_LETTER_CONDITIONALS();
 				excl_seen = star_seen = FALSE;
 				break;
 
 			case 'e':
+			case 'E':
 				curr = add_attach_line_item(&items);
 				curr->content = content_encodings[part->encoding];
 				curr->description = _(txt_mime_encoding);
-				SMALL_LETTER_CONDITIONALS();
-				excl_seen = star_seen = FALSE;
-				break;
-
-			case 'l':
-				if (!is_uue && part->language) {
-					curr = add_attach_line_item(&items);
-					curr->content = part->language;
-					curr->description = _(txt_mime_lang);
+				if (*fmt_ptr == 'e')
 					SMALL_LETTER_CONDITIONALS();
-				}
+				else
+					CAPITAL_LETTER_CONDITIONALS();
 				excl_seen = star_seen = FALSE;
 				break;
 
-			case 'n':
-				if (name) {
+			case 'f':
+			case 'F':
+				if (is_yenc) {
 					curr = add_attach_line_item(&items);
-					curr->content = name;
-					curr->description = _(txt_mime_name);
-					SMALL_LETTER_CONDITIONALS();
+					if (!part_str) {
+						str_len = snprintf(NULL, 0, "%d", part->yenc_part);
+						part_str = my_malloc(str_len + 1);
+						snprintf(part_str, str_len + 1, "%d", part->yenc_part);
+					}
+					curr->content = part_str;
+					curr->description = _(txt_yenc_part);
+					curr->flags |= ATTACH_ITEM_IS_YENC_PART;
+					if (*fmt_ptr == 'f')
+						SMALL_LETTER_CONDITIONALS();
+					else
+						CAPITAL_LETTER_CONDITIONALS();
 				}
 				excl_seen = star_seen = FALSE;
 				break;
 
-			case 's':
-				curr = add_attach_line_item(&items);
-				curr->content = part->subtype;
-				curr->description = _(txt_mime_content_subtype);
-				curr->flags |= ATTACH_ITEM_IS_SUBTYPE;
-				SMALL_LETTER_CONDITIONALS();
-				excl_seen = star_seen = FALSE;
-				break;
-
-			case 't':
-				curr = add_attach_line_item(&items);
-				curr->content = content_types[part->type];
-				curr->description = _(txt_mime_content_type);
-				curr->flags |= ATTACH_ITEM_IS_TYPE;
-				SMALL_LETTER_CONDITIONALS();
-				excl_seen = star_seen = FALSE;
-				break;
-
-			case 'z':
-				curr = add_attach_line_item(&items);
-				curr->content = ltobi(part->bytes);
-				curr->description = _(txt_mime_size);
-				SMALL_LETTER_CONDITIONALS();
-				excl_seen = star_seen = FALSE;
-				break;
-
-			case 'C':
-				if (charset) {
+			case 'g':
+			case 'G':
+				if (is_yenc) {
 					curr = add_attach_line_item(&items);
-					curr->content = charset;
-					curr->description = _(txt_mime_charset);
-					CAPITAL_LETTER_CONDITIONALS();
-				}
-				excl_seen = star_seen = FALSE;
-				break;
-
-			case 'D':
-				curr = add_attach_line_item(&items);
-				if (!line_cnt_str) {
-					line_cnt_str_len = snprintf(NULL, 0, "%d", part->line_count);
-					line_cnt_str = my_malloc(line_cnt_str_len + 1);
-					snprintf(line_cnt_str, line_cnt_str_len + 1, "%d", part->line_count);
+					if (!total_str) {
+						str_len = snprintf(NULL, 0, "%d", part->yenc_total);
+						total_str = my_malloc(str_len + 1);
+						snprintf(total_str, str_len + 1, "%d", part->yenc_total);
+					}
+					curr->content = total_str;
+					curr->description = _(txt_yenc_total);
+					curr->flags |= ATTACH_ITEM_IS_YENC_TOTAL;
+					if (*fmt_ptr == 'g')
+						SMALL_LETTER_CONDITIONALS();
+					else
+						CAPITAL_LETTER_CONDITIONALS();
 				}
-				curr->content = line_cnt_str;
-				curr->description = _(txt_mime_lines);
-				CAPITAL_LETTER_CONDITIONALS();
-				excl_seen = star_seen = FALSE;
-				break;
-
-			case 'E':
-				curr = add_attach_line_item(&items);
-				curr->content = content_encodings[part->encoding];
-				curr->description = _(txt_mime_encoding);
-				CAPITAL_LETTER_CONDITIONALS();
 				excl_seen = star_seen = FALSE;
 				break;
 
 			case 'I':
-				if (is_uue) {
+				if (is_uue || is_yenc) {
 					curr = add_attach_line_item(&items);
-					curr->content = is_uue == UUE_COMPLETE ? _(txt_uue_complete) : _(txt_uue_incomplete);
+					switch (section) {
+						case SECTION_UUE_COMPLETE:
+							curr->content = _(txt_uue_complete);
+							break;
+
+						case SECTION_UUE_INCOMPLETE:
+							curr->content = _(txt_uue_incomplete);
+							break;
+
+						case SECTION_YENC_PARTIAL:
+							curr->content = _(txt_yenc_partial);
+							break;
+
+						case SECTION_YENC_CORRUPT:
+							curr->content = _(txt_yenc_corrupt);
+							break;
+
+						case SECTION_YENC_COMPLETE:
+							curr->content = _(txt_yenc_complete);
+							break;
+
+						case SECTION_YENC_INCOMPLETE:
+							curr->content = _(txt_yenc_incomplete);
+							break;
+
+						default:
+							break;
+					}
 					CAPITAL_LETTER_CONDITIONALS();
 				}
 				excl_seen = star_seen = FALSE;
 				break;
 
+			case 'l':
 			case 'L':
-				if (!is_uue && part->language) {
+				if (!is_uue && !is_yenc && part->language) {
 					curr = add_attach_line_item(&items);
 					curr->content = part->language;
 					curr->description = _(txt_mime_lang);
-					CAPITAL_LETTER_CONDITIONALS();
+					if (*fmt_ptr == 'l')
+						SMALL_LETTER_CONDITIONALS();
+					else
+						CAPITAL_LETTER_CONDITIONALS();
 				}
 				excl_seen = star_seen = FALSE;
 				break;
 
+			case 'n':
 			case 'N':
 				if (name) {
 					curr = add_attach_line_item(&items);
 					curr->content = name;
 					curr->description = _(txt_mime_name);
-					CAPITAL_LETTER_CONDITIONALS();
+					if (*fmt_ptr == 'n')
+						SMALL_LETTER_CONDITIONALS();
+					else
+						CAPITAL_LETTER_CONDITIONALS();
 				}
 				excl_seen = star_seen = FALSE;
 				break;
 
+			case 's':
 			case 'S':
 				curr = add_attach_line_item(&items);
 				curr->content = part->subtype;
 				curr->description = _(txt_mime_content_subtype);
 				curr->flags |= ATTACH_ITEM_IS_SUBTYPE;
-				CAPITAL_LETTER_CONDITIONALS();
+				if (*fmt_ptr == 's')
+					SMALL_LETTER_CONDITIONALS();
+				else
+					CAPITAL_LETTER_CONDITIONALS();
 				excl_seen = star_seen = FALSE;
 				break;
 
+			case 't':
 			case 'T':
 				curr = add_attach_line_item(&items);
 				curr->content = content_types[part->type];
 				curr->description = _(txt_mime_content_type);
 				curr->flags |= ATTACH_ITEM_IS_TYPE;
-				CAPITAL_LETTER_CONDITIONALS();
+				if (*fmt_ptr == 't')
+					SMALL_LETTER_CONDITIONALS();
+				else
+					CAPITAL_LETTER_CONDITIONALS();
+				excl_seen = star_seen = FALSE;
+				break;
+
+			case 'v':
+			case 'V':
+				if (is_yenc) {
+					curr = add_attach_line_item(&items);
+					if (!part_size_str) {
+						if (part->yenc_part_size)
+							part_size_str = my_strdup(ltobi(part->yenc_part_size));
+						else
+							part_size_str = my_strdup("?");
+					}
+					curr->content = part_size_str;
+					curr->description = _(txt_yenc_part_size);
+					curr->flags |= ATTACH_ITEM_IS_YENC_PART_SIZE;
+					if (*fmt_ptr == 'v')
+						SMALL_LETTER_CONDITIONALS();
+					else
+						CAPITAL_LETTER_CONDITIONALS();
+				}
+				excl_seen = star_seen = FALSE;
+				break;
+
+			case 'w':
+			case 'W':
+				if (is_yenc) {
+					curr = add_attach_line_item(&items);
+					if (!total_size_str)
+						total_size_str = my_strdup(ltobi(part->yenc_total_size));
+					curr->content = total_size_str;
+					curr->description = _(txt_yenc_total_size);
+					curr->flags |= ATTACH_ITEM_IS_YENC_TOTAL_SIZE;
+					if (*fmt_ptr == 'w')
+						SMALL_LETTER_CONDITIONALS();
+					else
+						CAPITAL_LETTER_CONDITIONALS();
+				}
+				excl_seen = star_seen = FALSE;
+				break;
+
+			case 'x':
+			case 'X':
+				if (is_yenc) {
+					curr = add_attach_line_item(&items);
+					if (!crc_str) {
+						str_len = snprintf(NULL, 0, "0x%08lx", (unsigned long) part->yenc_crc);
+						crc_str = my_malloc(str_len + 1);
+						snprintf(crc_str, str_len + 1, "0x%08lx", (unsigned long) part->yenc_crc);
+					}
+					curr->content = crc_str;
+					curr->description = _(txt_yenc_crc);
+					if (*fmt_ptr == 'x')
+						SMALL_LETTER_CONDITIONALS();
+					else
+						CAPITAL_LETTER_CONDITIONALS();
+				}
 				excl_seen = star_seen = FALSE;
 				break;
 
+			case 'z':
 			case 'Z':
 				curr = add_attach_line_item(&items);
-				curr->content = ltobi(part->bytes);
+				if (!bytes_str)
+					bytes_str = my_strdup(ltobi(part->bytes));
+				curr->content = bytes_str;
 				curr->description = _(txt_mime_size);
-				CAPITAL_LETTER_CONDITIONALS();
+				if (*fmt_ptr == 'z')
+					SMALL_LETTER_CONDITIONALS();
+				else
+					CAPITAL_LETTER_CONDITIONALS();
 				excl_seen = star_seen = FALSE;
 				break;
 
@@ -780,7 +933,7 @@ build_attach_line(
 
 				case 'l':
 				case 'L':
-					if (!is_uue && part->language && curr) {
+					if (!is_uue && !is_yenc && part->language && curr) {
 						INSERT_SEP();
 						BUILD_ATTACH_ITEM();
 					}
@@ -798,8 +951,28 @@ build_attach_line(
 					excl_seen = star_seen = FALSE;
 					break;
 
+				case 'f':
+				case 'F':
+					if (is_yenc && curr) {
+						if (curr->prev && (curr->prev->flags & ATTACH_ITEM_IS_YENC_TOTAL))
+							INSERT_SLASH();
+						BUILD_ATTACH_ITEM();
+					}
+					excl_seen = star_seen = FALSE;
+					break;
+
+				case 'g':
+				case 'G':
+					if (is_yenc && curr) {
+						if (curr->prev && (curr->prev->flags & ATTACH_ITEM_IS_YENC_PART))
+							INSERT_SLASH();
+						BUILD_ATTACH_ITEM();
+					}
+					excl_seen = star_seen = FALSE;
+					break;
+
 				case 'I':
-					if (is_uue && curr) {
+					if ((is_uue || is_yenc) && curr) {
 						INSERT_SEP();
 						BUILD_ATTACH_ITEM();
 					}
@@ -830,6 +1003,39 @@ build_attach_line(
 					excl_seen = star_seen = FALSE;
 					break;
 
+				case 'v':
+				case 'V':
+					if (is_yenc && curr) {
+						if (curr->prev && (curr->prev->flags & ATTACH_ITEM_IS_YENC_TOTAL_SIZE))
+							INSERT_SLASH();
+						else
+							INSERT_SEP();
+						BUILD_ATTACH_ITEM();
+					}
+					excl_seen = star_seen = FALSE;
+					break;
+
+				case 'w':
+				case 'W':
+					if (is_yenc && curr) {
+						if (curr->prev && (curr->prev->flags & ATTACH_ITEM_IS_YENC_PART_SIZE))
+							INSERT_SLASH();
+						else
+							INSERT_SEP();
+						BUILD_ATTACH_ITEM();
+					}
+					excl_seen = star_seen = FALSE;
+					break;
+
+				case 'x':
+				case 'X':
+					if (is_yenc && curr) {
+						INSERT_SEP();
+						BUILD_ATTACH_ITEM();
+					}
+					excl_seen = star_seen = FALSE;
+					break;
+
 				case 'z':
 				case 'Z':
 					if (curr) {
@@ -845,7 +1051,15 @@ build_attach_line(
 		}
 	}
 
+	FreeIfNeeded(bytes_str);
 	FreeIfNeeded(line_cnt_str);
+	if (is_yenc) {
+		FreeIfNeeded(crc_str);
+		FreeIfNeeded(part_size_str);
+		FreeIfNeeded(part_str);
+		FreeIfNeeded(total_size_str);
+		FreeIfNeeded(total_str);
+	}
 
 	if (items) {
 		while (last) {
@@ -865,31 +1079,96 @@ put_attach(
 	t_bool wrap_lines,
 	t_part *part,
 	int depth,
-	int is_uue,
+	enum section_type section,
 	const char *name,
 	const char *charset)
 {
-	char *attach_line = build_attach_line(part, depth, cCOLS - 1, is_uue, name, charset);
+	char *attach_line;
+	t_bool is_uue = (section == SECTION_UUE_COMPLETE || section == SECTION_UUE_INCOMPLETE);
+	t_bool is_yenc = (section >= SECTION_YENC_COMPLETE /* && section <= SECTION_YENC_CORRUPT */);
 
-	if (is_uue)
-		put_cooked(LEN, wrap_lines, C_UUE, "%s", attach_line);
+	assert(((void) "put_attach() failed. part == NULL", part != NULL));
+
+	attach_line = build_attach_line(part, depth, cCOLS - 1, section, name, charset);
+
+	if (is_uue || is_yenc)
+		put_cooked(LEN, wrap_lines, is_uue ? C_UUE : C_YENC, "%s", attach_line);
 	else
 		put_cooked(LEN, wrap_lines, C_ATTACH, "%s", attach_line);
 
 	FreeIfNeeded(attach_line);
 
-	if (!is_uue && part->description)
+	if (!is_uue && !is_yenc && part->description)
 		put_cooked(LEN, wrap_lines, C_ATTACH, _(txt_mime_description), depth, "", part->description);
 
 	if (part->next != NULL || IS_PLAINTEXT(part)) {
-		if (is_uue)
-			put_cooked(1, wrap_lines, C_UUE, "\n");
+		if (is_uue || is_yenc)
+			put_cooked(1, wrap_lines, is_uue ? C_UUE : C_YENC, "\n");
 		else
 			put_cooked(1, wrap_lines, C_ATTACH, "\n");
 	}
 }
 
 
+#define GET_YENC_SECTION_TYPE() do { \
+		/* as we don't have the full crc of multiparts we must compare against pcrc if set */ \
+		if (y_epcrc) { \
+			if (y_ccrc != y_epcrc) { \
+				section_type = SECTION_YENC_CORRUPT; \
+				break; \
+			} \
+		} else { \
+			if (y_ecrc && (y_ccrc != y_ecrc)) { \
+				section_type = SECTION_YENC_CORRUPT; \
+				break; \
+			} \
+		} \
+		if (y_part > y_total || y_total > 1) { \
+			if (curruue->bytes != y_esize) { \
+				section_type = SECTION_YENC_CORRUPT; \
+				break; \
+			} else { \
+				section_type = SECTION_YENC_PARTIAL; \
+				break; \
+			} \
+		} else { \
+			if (curruue->bytes != y_bsize || curruue->bytes != y_esize) { \
+				section_type = SECTION_YENC_CORRUPT; \
+				break; \
+			} \
+		} \
+		section_type = SECTION_YENC_COMPLETE; \
+	} while (0)
+
+#define PUT_YENC_HEADER() do { \
+		curruue->yenc_part = y_part ? y_part : 1; /* fixup display when no =part was found */ \
+		curruue->yenc_total = y_total ? y_total : 1; /* fixup display when no =total was found */ \
+		curruue->yenc_part_size = y_pend && (y_pend - y_pbegin) ? y_pend - y_pbegin : y_bsize == y_esize ? y_bsize : 0; \
+		curruue->yenc_total_size = y_bsize; \
+		curruue->yenc_crc = y_ccrc; \
+		put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, section_type, get_filename(curruue->params), content_encodings[curruue->encoding]); \
+	} while (0)
+
+#ifdef INLINE_DEBUG_MIME
+#	define DEBUG_PUT_YENC_INVALID_ITEM(what, value, where) do { \
+		put_cooked(LEN, wrap_lines, C_YENC, "[-- Error: invalid %s \"%s\" in %s --]", (what), (value), (where)); \
+	} while (0)
+#	define DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM(what, where) do { \
+		put_cooked(LEN, wrap_lines, C_YENC, "[-- Error: missing/empty %s parameter in %s --]", (what), (where)); \
+	} while (0)
+#	define DEBUG_PUT_YENC_UNEXPECTED_ITEM(what) do { \
+		put_cooked(LEN, wrap_lines, C_YENC, "[-- Error: unexpected %s --]", (what)); \
+	} while (0)
+#	define DEBUG_PUT_YENC_CRC32_MISMATCH(computed, expected) do { \
+		put_cooked(LEN, wrap_lines, C_YENC, "[-- Error: crc32 mismatch, computed 0x%08lx != 0x%08lx expected --]", (computed), (expected)); \
+	} while (0)
+#else
+#	define DEBUG_PUT_YENC_INVALID_ITEM(what, value, where) do {} while (0)
+#	define DEBUG_PUT_YENC_UNEXPECTED_ITEM(what) do {} while (0)
+/* #	define DEBUG_PUT_YENC_CRC32_MISMATCH(computed, expected) do {} while (0) */
+#endif /* INLINE_DEBUG_MIME */
+
+
 /*
  * Decodes text bodies, remove sig's, detects uuencoded sections
  */
@@ -899,29 +1178,59 @@ process_text_body_part(
 	FILE *in,
 	const char *charset,
 	t_part *part,
-	int hide_uue)
+	int hide_inline_data)
 {
 	char *rest = NULL;
-	char *line = NULL, *buf, *tmpline;
-	size_t max_line_len = 0, len, len_blank;
-	int flags, lines_left;
+	char *line = NULL, *buf;
+	char *raw_line = NULL;
+	char *y_name = NULL;			/* yenc, filename */
+	char *cp;
+	char *ncs;						/* named capture */
+	static const signed char xxenc[] = {	/* xxdecode table */
+		0x00, 0x7f, 0x01, 0x7f, 0x7f,
+		0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09,
+		0x0a, 0x0b, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f,
+		0x7f, 0x0c, 0x0d, 0x0e, 0x0f, 0x10, 0x11, 0x12,
+		0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a,
+		0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 0x20, 0x21, 0x22,
+		0x23, 0x24, 0x25, 0x7f, 0x7f, 0x7f, 0x7f, 0x7f,
+		0x7f, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b, 0x2c,
+		0x2d, 0x2e, 0x2f, 0x30, 0x31, 0x32, 0x33, 0x34,
+		0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b, 0x3c,
+		0x3d, 0x3e, 0x3f };
+	int lines_left;
+	int y_part = 0;					/* yenc, current part */
+	int y_total = 0;				/* yenc, total parts */
+	int is_uubody;					/* Set when current line looks like a uuencoded=1/xxencoded=2 line */
+	int sum;
+	unsigned int flags;
+	unsigned int section = TEXT_SECTION;
 	unsigned int lines_skipped = 0;
-	t_bool in_sig = FALSE;			/* Set when in sig portion */
-	t_bool in_uue = FALSE;			/* Set when in uuencoded section */
-	t_bool in_verbatim = FALSE;		/* Set when in verbatim section */
-	t_bool verbatim_begin = FALSE;	/* Set when verbatim_begin_regex matches */
-	t_bool is_uubegin;				/* Set when current line starts a uue part */
-	t_bool is_uubody;				/* Set when current line looks like a uuencoded line */
+	unsigned long y_bsize = 0L;		/* yenc, size in begin line */
+	unsigned long y_esize = 0L;
+	unsigned long y_pbegin = 0L;		/* yenc, part start offset */
+	unsigned long y_pend = 0L;		/* yenc, part end offset */
+	unsigned long lines_hidden = 0L;
+	size_t max_line_len = 0, len, raw_len;
+	uint32_t y_ccrc = 0L;			/* computed crc */
 	t_bool first_line_blank = TRUE;	/* Unset when first non-blank line is reached */
 	t_bool put_blank_lines = FALSE;	/* Set when previously skipped lines needs to put */
 	t_part *curruue = NULL;
-#ifdef HAVE_LIBURIPARSER
+#if defined(HAVE_LIBURIPARSER) || defined(HAVE_LIBCURL)
 	REGEX_SIZE *offsets;
-	char *u = NULL;
+	char *u;
 	size_t l;
+#endif /* HAVE_LIBURIPARSER || HAVE_LIBCURL */
+#ifdef HAVE_LIBURIPARSER
 	UriUriA uri;
 	UriParserStateA state;
+#else
+#	ifdef HAVE_LIBCURL
+	CURLU *curl;
+	char *nu;
+#	endif /* HAVE_LIBCURL */
 #endif /* HAVE_LIBURIPARSER */
+	unsigned int non_attach_lines = 0;
 
 	if (part->uue) {				/* These are redone each time we recook/resize etc.. */
 		free_parts(part->uue);
@@ -965,18 +1274,16 @@ process_text_body_part(
 				 * especially if we must resize it.
 				 * So copy buf to line (and resize line if necessary).
 				 */
-				if (max_line_len < strlen(buf) + 2 || !line) {
-					max_line_len = strlen(buf) + 2;
-					line = my_realloc(line, max_line_len);
+				if (max_line_len <= strlen(buf) + 1 || !line) {
+					max_line_len = strlen(buf) + 1;
+					line = my_realloc(line, max_line_len + 1);
 				}
-				strcpy(line, buf);
-
 				/*
 				 * FIXME: Some code in cook.c expects a '\n' at the end
 				 * of the line. As tin_fgets() strips trailing '\n', re-add it.
 				 * This should probably be fixed in that other code.
 				 */
-				strcat(line, "\n");
+				snprintf(line, max_line_len + 1, "%s\n", buf);
 
 				--lines_left;
 				break;
